# Standard messages

ROS2 Nodes communicate using *messages*. If a node wants to publish a certain kind of message it must obey the standard set by the message.
Many kinds of messages are already defined by ROS, and can be found at random places because ROS is used by nerds who don't need documentation.
Yes, I'm slightly salty //Johan

For an overview of messages, perhaps this is of interest: https://docs.ros.org/en/foxy/Concepts/About-ROS-Interfaces.html
<iframe
  src="https://docs.ros.org/en/foxy/Concepts/About-ROS-Interfaces.html"
  style="width:100%; height:300px;"
></iframe>
Below we provide some links to documentation for important types of messages we use.

## Sensor Messages


For ROS2 the source code for geometry messages can be found here:
https://github.com/ros2/common_interfaces/tree/foxy/sensor_msgs


They are also defined on a higher level in ROS1 here:
<iframe
  src="http://wiki.ros.org/sensor_msgs"
  style="width:100%; height:300px;"
></iframe>


## Geometry Messages

For ROS2 the source code for sensor messages can be found here:
https://github.com/ros2/common_interfaces/tree/foxy/geometry_msgs


They are also defined on a higher level in ROS1 here:
<iframe
  src="http://wiki.ros.org/geometry_msgs"
  style="width:100%; height:300px;"
></iframe>

