//================
//-----Topics-----
var goal_publisher = new ROSLIB.Topic({
    ros : ros,
    name : '/sm_goal',
    messageType : 'lhw_interfaces/Behaviour'
  });
//================


//================
//Global variables

var sm = new StateMachine()

var behaviour_definitions = [];
$.ajax({
  async: false,
  url: '../goal/Behaviours.json',
  success: function(definitions) {
    behaviour_definitions = definitions.Behaviours
  }
});

var editor = new Editor(behaviour_definitions)

//================

function updateUI(){
  document.getElementById("stateMachine").innerHTML = sm.getHTML();
  document.getElementById("editor").innerHTML = editor.getHTML();
}

updateUI()



/*
function send(){
    let behaviour = document.getElementById('behaviours').value
    let specific_id_value = document.getElementById('specific_id').value == "yes"
    let specific_type_value = document.getElementById('specific_type').value == "yes"
    let id_value = document.getElementById('id').value
    let type_value = document.getElementById('type').value
    let map_name_value = document.getElementById('map_name').value
    let at_start_value = document.getElementById('at_start').value
    let behaviour_timeout_in_sec_value = document.getElementById('behaviour_timeout_in_sec').value

    goal_publisher.publish({
        what: behaviour,
        specificid: specific_id_value,
        specifictype: specific_type_value,
        id: id_value,
        type: type_value,
        mapname:  map_name_value,
        atstart: at_start_value,
        behaviourtimeoutinsec: behaviour_timeout_in_sec_value
    }); 
}

document.getElementById('specific_id_container').style.display = "none"
  document.getElementById('specific_type_container').style.display = "none"
  document.getElementById('id_container').style.display = "none"
  document.getElementById('type_container').style.display = "none"
  document.getElementById('map_name_container').style.display = "none"
  document.getElementById('at_start_container').style.display = "none"
  document.getElementById('behaviour_timeout_in_sec_container').style.display = "none"
    
  document.getElementById('send_button').addEventListener('click', function (event) {
    event.preventDefault();
    send()
  });

  function behaviourUpdate(behaviour){
    console.log(behaviour)
    document.getElementById('specific_id_container').style.display = "none"
    document.getElementById('specific_type_container').style.display = "none"
    document.getElementById('id_container').style.display = "none"
    document.getElementById('type_container').style.display = "none"
    document.getElementById('map_name_container').style.display = "none"
    document.getElementById('at_start_container').style.display = "none"
    
    
    if (behaviour == "find_person:FindPerson"){
      document.getElementById('specific_id_container').style.display = "block"
      document.getElementById('id_container').style.display = "block"
    }
    if (behaviour == "have_a_conversation:HaveAConversation"){
      document.getElementById('type_container').style.display = "block"
      document.getElementById('at_start_container').style.display = "block"
    }

    document.getElementById('send_button').style.display = "block"
    document.getElementById('behaviour_timeout_in_sec_container').style.display = "block"
    
  };

*/