import py_trees

from .behaviour_copy import Behaviour #TODO: Move behaviours to here

#TODO: Tidy this up when finished
from std_msgs.msg import Bool, String, Empty, Int16
from lhw_interfaces.msg import Entities, Response, Entity, Result
from geometry_msgs.msg import Twist, Pose, PoseStamped
import numpy as np


""" Standby """
class Standby (py_trees.behaviour.Behaviour):
    def __init__(self, name, node) -> None:
        super(Standby, self).__init__(name)
        self.node = node

    def setup(self, **kwargs):
        self.logger.debug("  %s [Standby::setup()]" % self.name)
        

    def initialise(self):
        # todo: make pepper do the standby pose
        self.logger.debug("  %s [Standby::initialise()]" % self.name)

    def update(self):
        self.logger.debug("  %s [Standby::update()]" % self.name)
        return py_trees.common.Status.RUNNING

    def terminate(self, new_status):
        self.logger.debug("  %s [Standby::terminate().terminate()][%s->%s]" % (self.name, self.status, new_status))


""" Is Head Touched """
class IsHeadTouched (py_trees.behaviour.Behaviour):
    def __init__(self, name, node) -> None:
        super(Standby, self).__init__(name)
        self.node = node

    def setup(self, **kwargs):
        self.logger.debug("  %s [IsHeadTouched::setup()]" % self.name)

    def initialise(self):
        # todo: make pepper do the standby pose
        self.logger.debug("  %s [IsHeadTouched::initialise()]" % self.name)

    def update(self):
        self.logger.debug("  %s [IsHeadTouched::update()]" % self.name)
        if (head_touched):
            return py_trees.common.Status.SUCCESS
        else:
            return py_trees.common.Status.FAILURE

    def terminate(self, new_status):
        self.logger.debug("  %s [IsHeadTouched::terminate().terminate()][%s->%s]" % (self.name, self.status, new_status))