"""
    Commands to make robot move servos (not wheels),
    which can be to point at something, to do a visual search, etc.
    QI's animated-speech is only thing not handled here.
"""

import rclpy
from rclpy.node import Node

from lhw_interfaces.msg._goal import Goal


class MotionBehaviours(Node):
    def __init__(self):
        super().__init__('motion_behaviours')
        self.log = self.get_logger()
        self.log.warn(self.__class__.__name__+" has not yet been implemented.")  # TODO


def main(args=None):
    rclpy.init(args=args)
    motion_behaviour_node = MotionBehaviours()

    rclpy.spin(motion_behaviour_node)

    motion_behaviour_node.destroy_node()
    rclpy.shutdown()


if __name__ == '__main__':
    main()


