# NLP EMOTION CORE - @nlp

**TLDR**  
Make sure to build the project.

Start the following nodes:
- text_2_emotion_1 (.py)
- text_2_emotion_2 (.py)
- nlp_emotion_core (.py)

Listen to the topic 'nlp_emotion'
To test the system post text responses to the topic 'dialogflow_response' as the following:

ros2 topic pub /dialogflow_response lhw_interfaces/msg/Response "{recognized_text: 'I am feeling happy today!'}" -1

**A bit more details**

Two nodes perofm text to emotion analysis:
- text_2_emotion_1 (.py)
- text_2_emotion_2 (.py)

Both of these nodes take input from the topic 'dialogflow_resonse' and publish to the topic 'text_emotion'.

The node 'nlp_emotion_core' listens for events on the 'text_emotion' topic. It analyzes the input, weights the different emotions and publishes the best emotion(results) to the 'nlp_emotion' topic.