"""
    Takes snippets of audio from microphone, sends it to Google's DialogFlow API
    and forwards the extracted intent, etc.
"""

import rclpy
from rclpy.node import Node
from std_msgs.msg import String, Int16
from lhw_interfaces.msg import Audio
from lhw_interfaces.msg import Response
from lhw_interfaces.msg import Parameter
import dialogflow_v2 as dialogflow
from collections import deque
from google.oauth2 import service_account
import os
import time
import pygame


#import scipy.io.wavfile as wavf
import numpy as np


import pyaudio
import wave
#import sys
#import threading

'''
def play():
    CHUNK = 1024

    wf = wave.open("out.wav", 'rb')

    p = pyaudio.PyAudio()

    print(wf.getsampwidth())

    stream = p.open(format=p.get_format_from_width(wf.getsampwidth()),
                    channels=wf.getnchannels(),
                    rate=wf.getframerate(),
                    output=True)

    data = wf.readframes(CHUNK)

    while data != '':
        stream.write(data)
        data = wf.readframes(CHUNK)

    stream.stop_stream()
    stream.close()

    p.terminate()
'''






class DialogFlowCommunicator(Node):
    def __init__(self):
        #play()
        super().__init__('dialogflow')

        self.audio_chunk_queue = []    # Buffer where callback stores audio samples coming from audio_topic. Audio chunks are later removed from it and sent to Dialogflow
        self.max_queue_size = 1000000000
        
        self.buffer_sub = self.create_subscription(Audio, 'microphone_buffer', self.audio_cb, 10)
        self.response_pub = self.create_publisher(Response, 'response', 10)
        self.log = self.get_logger()
        self.log.warn(self.__class__.__name__+" has not yet been implemented.")  # TODO
        self.buffer_pub = self.create_publisher(Int16, "buffer", 10)

        #self.stream_timer = self.create_timer(0.00001, self.detect_intent_stream) 
        #self.text_cb("potato")

        self.x = 0
        fs=48000
        #.mixer.pre_init(fs, -16, 1, 8192*5)
        #pygame.mixer.init()


        wav_output_filename = "pepper_ljud.wav"
        chans = 1
        samp_rate = 48000
        chunk = 8192

        #audio = pyaudio.PyAudio() # create pyaudio instantiation
        print("hej1")
        # create pyaudio stream
        #stream = audio.open(format = pyaudio.paInt16,rate = samp_rate,channels = chans, input = True)#, \
                            #input = True, \
                            #frames_per_buffer=chunk)

        print("hej2")
        
        print("hej3")
        
        #wavefile.close()

    
    def audio_cb(self, audio_msg):
        #self.log.info(audio_msg.data)
        #self.log.error("Text callback in Dialogflow has not yet been implemented.")  # TODO
        if True: #len(self.audio_chunk_queue) < self.max_queue_size:
            #print(str(audio_msg.data.itemsize))
            #print(str(audio_msg.data))
            #print(len(str(audio_msg.data)))
            #sound_data_interlaced = np.fromstring(str(audio_msg.data), dtype=np.int16)
            #print(sound_data_interlaced.shape)
            #sound_data = np.reshape(sound_data_interlaced, (4, 48000), 'F')
            #print(sound_data.shape)
            #self.audio_chunk_queue.append(sound_data[0].tostring())
            #print(sound_data[0].tostring())
            #self.f = open("demofile2.txt", "a")
            #for bit in audio_msg.data:
            #    self.f.write(str(bit))
            #self.f.write("\n")
            #self.f.close()
            #self.log.info(str(audio_msg.data))
            #chunk = np.array(audio_msg.data, dtype=np.int16)
            #count = 0 
            #for bit in chunk[::3]:
            #    #count += 1
            #    #if count == 3:
            #    msg = Int16()
            #        #print(type(bit))

            #    msg.data = int(bit)
            #    self.buffer_pub.publish(msg) 
            #    #count = 0
            #
            #return
            #chunk = np.array(audio_msg.data, dtype=np.int16) 
            self.audio_chunk_queue.extend(audio_msg.data)
            #print(type(audio_msg.data.tobytes()))
            self.get_logger().info("hello!")
            #print("DONEEEEEasdas")
            if len(self.audio_chunk_queue) >= 20*8192:
                #print(bytes(self.audio_chunk_queue))

                self.wavefile = wave.open("wav_output_filename.wav",'wb')
                self.wavefile.setnchannels(1)
                self.wavefile.setsampwidth(2)
                self.wavefile.setframerate(48000)
                self.wavefile.writeframes(bytes(self.audio_chunk_queue))
                self.wavefile.close()
                print("DONEEEEE")
                self.get_logger().info("DONE!")

            return

            chunk = np.array(audio_msg.data) 
            sound = pygame.sndarray.make_sound(chunk)
            sound.play()
            return

            self.audio_chunk_queue.extend(audio_msg.data)
            if len(self.audio_chunk_queue) == 5*8192:
                chunk = np.array(self.audio_chunk_queue, dtype=np.int16) 
                print(str(chunk))
                print(str(type(chunk)))
                print(str(len(chunk)))
                sound = pygame.sndarray.make_sound(chunk)

                #print("Before play")
                #raw_input()
                sound.play()
            elif len(self.audio_chunk_queue) > 5*8192:
                self.audio_chunk_queue = []

            
                
        else:
            self.log.warn("Audio chunk queue is full, flushing!")
            #print(self.audio_chunk_queue)
            #self.audio_chunk_queue = deque()
            



 

def main(args=None):
    rclpy.init(args=args)
    dialogflow_node = DialogFlowCommunicator()
    
    rclpy.spin(dialogflow_node)
    dialogflow_node.destroy_node()
    rclpy.shutdown()



if __name__ == '__main__':
    main()


