import os
import launch
import launch.actions
import launch.substitutions
import launch_ros.actions


def generate_launch_description():
    
    if "PEPPER_IP" in os.environ:
        pepper_ip = os.environ.get('PEPPER_IP')
    else:
        pepper_ip = 'localhost'
    
    return launch.LaunchDescription([
        launch_ros.actions.Node(
            package='lhw_qi',
            executable='manual_composition',
            arguments=['-i', pepper_ip],
            output='screen'),
    ])
