from launch import LaunchDescription
from launch_ros.actions import Node


def generate_launch_description():
    return LaunchDescription([
        Node(
            package='lhw_vision',
            executable='debug_image_node'
        ),
        Node(
            package='lhw_vision',
            executable='yolo_node'
        ),
        Node(
            package='lhw_vision',
            executable='densesense'
        ),
        Node(
            package='lhw_vision',
            executable='tracker_node'
        ),
        Node(
            package='lhw_vision',
            executable='image_to_world_node'
        ),
        ]
    )
