"""
    Uses Axelwickm's DenseSense library (based on Facebook's DensePose) to detect people
    and their whole surfaces, sanitize this data, do basic tracking, detect clothing, and
    actions.
"""

import rclpy
from rclpy.node import Node


class DenseSenseWrapper(Node):
    def __init__(self):
        super().__init__('densesense')
        self.log = self.get_logger()
        self.log.warn(self.__class__.__name__+" has not yet been implemented.")  # TODO


def main(args=None):
    rclpy.init(args=args)
    densesense_node = DenseSenseWrapper()

    rclpy.spin(densesense_node)

    densesense_node.destroy_node()
    rclpy.shutdown()


if __name__ == '__main__':
    main()
