# User Story/Description
Write on the format **As a <User|Developer|Volunteer> I want to <Activity|Result> so that <Benefit>.**
Example: **As a Developer I want Continuous Integration so that my code gets checked for errors automatically and I save time**

# Definition of Done
When is this issue done? Be definite and specific.
Example: **A continuous integration pipeline runs a python linter to check for Google code standard violations**.

# How
If you know roughly how to complete this issue, lay it out here. It can be involved files, techniques or algorithms, etc.
Example: **Create a gitlab-ci.yml file and add PyLint to the project, add it to the yml file and test that it runs when pushing up code**