class Behaviour {
  constructor(id, parent, label = "Undefined") {
    this.id = id
    this.parent = parent
    this.label = label
    this.name = false
    this.input_data = []
  }

  getHTML(){
    var input_data = ""
    this.input_data.forEach( input => {
      if (!input.value){
        input.value = ""
      }
      input_data += "<div class='input_data'> <div class=input_data-label>" + input.label + ":</div> <div class=input_data-value>" + input.value + "</div></div>"
    })

    var name = "<div class='title'> " + this.label + "</div>";
    var editbutton = ""
    if (this.id > 0) {
      editbutton ="<button onclick='editor.open(" + this.id + " )'> Edit </button>";
    }
    
    var nextbutton ="<button onclick='sm.addNext(" + this.id + " )'> Add next </button>";
    var html = "<div class='behaviour-container'>" + input_data + name + "<div class='buttons'>" + editbutton + nextbutton + "</div></div>"
    return html
  }


}
