from .behaviour import Behaviour
from std_msgs.msg import String
from lhw_interfaces.msg._result import Result

class GeneralBehaviour(Behaviour):
    def __init__(self, node, args):
        super().__init__(node, args)
        self.node = node

        node.log.info("GeneralBehaviour started")

        # ------------- State's properties --------------     
    
        self.state_done = False

        self.state_name = String()
        self.state_name.data = "GENERAL_STATE"

        self.run_timer = self.node.create_timer(1, self.run) 

    def run(self):  
        if self.state_done or self._behaviour_timeout():
            self.run_timer.cancel()
            self.stop_robot()
            self.send_result()
            return
    


    #def subscriber_cb(self, data):
    #    self.state_done = True

