

class DataBase:
    
    def __init__(self):

        self.categories = {
            "furniture": ["table", "chair"],
            "persons": ["person"],
            "fruits": ["apple", "banana"]
        }

        self.seen_entities = {}
        self.nlp_parameters = []

    def add_to_db(self, collection, element):
        if collection == "seen_entities":
            self.seen_entities[element["id"]] = element
            print(self.seen_entities)

        if collection == "nlp_parameters":
            self.nlp_parameters.append(element)
            print(self.seen_entities)
    
    def get_categories_of_type(self, type):
        possible_categories = []

        for category, types_in_category in self.categories.items():
            if type in types_in_category:
                possible_categories.append(category)
        
        return possible_categories

    def get_entity(self, id):
        return self.seen_entities.get(id)
