import numpy as np
from lhw_vision.tracker.reid import ReID

reid = ReID(memory_size=1000,knn=3)
image = (np.random.rand(100,100,3)*255).astype(np.uint8)
for k in range(100):
    person = {'tracked_id':k,'bbox':(5,10,25,50)}
    reid.add(person,image)
    print(reid(person,image))
print(reid.assigned_ids)