import numpy as np
from lhw_vision.tracker import VisionTracker
import logging
logging.basicConfig()

log = logging.getLogger(f"{__file__}")
log.setLevel('DEBUG')
tracker = VisionTracker(log)
image = (np.random.rand(100,100,3)*255).astype(np.uint8)
detections = {"person":[{"type":"person","bbox":[10,20,30,40]},
                        {"type":"person","bbox":[10,30,30,50]},
                        {"type":"person","bbox":[20,20,30,40]},
                        {"type":"person","bbox":[15,20,25,40]}]}
tracker.track(detections,image)
print(tracker.get_targets())